﻿UIPanelWindows["GuildFinderFrame"] = { area = "left", pushable = 1, whileDead = 1 };
 
local GUILD_BUTTON_HEIGHT = 84;
local GUILD_COMMENT_HEIGHT = 50;
local GUILD_COMMENT_BORDER = 10;
local APP_BUTTON_HEIGHT = 30;
local INTEREST_TYPES = {"QUEST", "DUNGEON", "RAID", "PVP", "RP"};

local GuildFinderRecrutingGuilds = {};

function GuildFinderFrame_OnLoad(self)
    PanelTemplates_SetNumTabs(self, 3);
    self.selectedTab = 1;
    PanelTemplates_UpdateTabs(self);
    self.Inset:SetPoint("TOPLEFT", 4, -64); 
 
    local factionGroup = UnitFactionGroup("player");
    if ( factionGroup == "Alliance" ) then
        GuildFinderFrameTabardEmblem:SetTexture("Interface\\FriendsFrame\\PlusManz-Alliance");
        GuildFinderFrameTabardEmblem:SetPoint("TOPLEFT", 1, 0);
    else
        GuildFinderFrameTabardEmblem:SetTexture("Interface\\FriendsFrame\\PlusManz-Horde"); 
        GuildFinderFrameTabardEmblem:SetPoint("TOPLEFT", 0, 0);
    end
     
    GuildFinderFrameTitleText:SetText(LOOKINGFORGUILD);
     
    self:RegisterEvent("PLAYER_GUILD_UPDATE");
    self:RegisterEvent("LF_GUILD_BROWSE_UPDATED");
    self:RegisterEvent("LF_GUILD_MEMBERSHIP_LIST_UPDATED");
    self:RegisterEvent("LF_GUILD_MEMBERSHIP_LIST_CHANGED");
    
    ChatFrame1:AddMessage("|cFF0080FF[GuildFinder] "..GUILDFINDER_WORDS_GREETING_MSG);
    
    SlashCmdList["GFND"] = GuildFinderFrame_Toggle
    SLASH_GFND1 = "/gfnd";
    SLASH_GFND2 = "/пг";
end
 
function GuildFinderFrame_OnShow(self)
    PlaySound("igCharacterInfoOpen");
    local canBeTank, canBeHealer, canBeDPS = true, true, true;--UnitGetAvailableRoles("player");
     
    if ( canBeTank ) then
        LFG_EnableRoleButton(GuildFinderTankButton);
        GuildFinderTankButtonText:SetFontObject("GameFontHighlightSmall");
    else
        LFG_PermanentlyDisableRoleButton(GuildFinderTankButton);
        GuildFinderTankButtonText:SetFontObject("GameFontDisableSmall");
    end
     
    if ( canBeHealer ) then
        LFG_EnableRoleButton(GuildFinderHealerButton);
        GuildFinderHealerButtonText:SetFontObject("GameFontHighlightSmall");
    else
        LFG_PermanentlyDisableRoleButton(GuildFinderHealerButton);
        GuildFinderHealerButtonText:SetFontObject("GameFontDisableSmall");
    end
     
    if ( canBeDPS ) then
        LFG_EnableRoleButton(GuildFinderDamagerButton);
        GuildFinderDamagerButtonText:SetFontObject("GameFontHighlightSmall");
    else
        LFG_PermanentlyDisableRoleButton(GuildFinderDamagerButton);
       GuildFinderDamagerButtonText:SetFontObject("GameFontDisableSmall");
    end
 
    UpdateMicroButtons();
    RequestGuildMembershipList();
    RequestRecruitingGuildsList();
end
 
function GuildFinderFrame_OnEvent(self, event, ...)
    if ( event == "PLAYER_GUILD_UPDATE" ) then
        if ( IsInGuild() and self:IsShown() ) then
            HideUIPanel(self);
        end
    elseif ( event == "LF_GUILD_BROWSE_UPDATED" ) then
        --print("up");
        GuildFinder_Update();
	--GuildFinderUpdateGuildsList();
    elseif ( event == "LF_GUILD_MEMBERSHIP_LIST_UPDATED" ) then
        local numAppsLeft = ...;
        GuildFinderBrowseFrameRequestsLeft:SetFormattedText(GUILD_FINDER_REQUESTS_LEFT, numAppsLeft);
        GuildFinderApps_Update();
    elseif ( event == "LF_GUILD_MEMBERSHIP_LIST_CHANGED" ) then
        RequestGuildMembershipList();
    end
end
 
function GuildFinderFrame_OnHide(self)
    PlaySound("igCharacterInfoClose");
    UpdateMicroButtons();
end
 
function GuildFinderFrame_Toggle()
    if ( GuildFinderFrame:IsShown() ) then
        HideUIPanel(GuildFinderFrame);
    else
        ShowUIPanel(GuildFinderFrame);
    end
end
 
function GuildFinderFrame_Update()
    if ( GuildFinderFrame.selectedTab == 1 ) then
        GuildFinderStartFrame:Show();
        GuildFinderBrowseFrame:Hide();
        GuildFinderAppsFrame:Hide();
    elseif ( GuildFinderFrame.selectedTab == 2 ) then
        GuildFinderStartFrame:Hide();
        GuildFinderBrowseFrame:Show();
        GuildFinderAppsFrame:Hide();
    else
        GuildFinderStartFrame:Hide();
        GuildFinderBrowseFrame:Hide();
        GuildFinderAppsFrame:Show();
    end
end
 
--*******************************************************************************
--   Settings frame
--*******************************************************************************
 
function GuildFinderPlaystyleButton_OnClick(index, userClick)
    local param;
    if ( index == 1 ) then
        GuildFinderCasualButton:SetChecked(1);
        GuildFinderModerateButton:SetChecked(nil);
        GuildFinderHardcoreButton:SetChecked(nil);
        param = LFGUILD_PARAM_CASUAL;
    elseif ( index == 2 ) then
        GuildFinderCasualButton:SetChecked(nil);
        GuildFinderModerateButton:SetChecked(1);
        GuildFinderHardcoreButton:SetChecked(nil);
        param = LFGUILD_PARAM_MODERATE;
    else
        GuildFinderCasualButton:SetChecked(nil);
        GuildFinderModerateButton:SetChecked(nil);
        GuildFinderHardcoreButton:SetChecked(1);
        param = LFGUILD_PARAM_HARDCORE;
    end
    if ( userClick ) then
        SetLookingForGuildSettings(param, true);--***********************************************************************************************************************************
    end
end

local slider_value=nil
function GuildFinderGuildLvlSlider_OnValueChanged(self)
    slider_value = self:GetValue();
    g=_G[self:GetName().."Text"]
    g:SetText(self.text .. " (" .. slider_value .. ")");
    return self:GetValue();
end

function GuildFinderGuildNumMembersSlider_OnValueChanged(self)
    slider_value = self:GetValue();
    if (slider_value == 0) then
        slider_value = 1;
    end
    g=_G[self:GetName().."Text"]
    g:SetText(self.text .. " (" .. slider_value .. ")");
    return self:GetValue();
end

function GuildFinderGuildLvl_OnLoad(self,vText,Min,Max,Step,Value)
    self.text = vText;

    --i=(Min*100).."%";
    --j=(Max*100).."%";

    g=_G[self:GetName().."Text"]
    g:SetText(vText);
    g=_G[self:GetName().."Low"]
    g:SetText(Min);
    g=_G[self:GetName().."High"]
    g:SetText(Max);
    self:SetMinMaxValues(Min,Max);
    self:SetValueStep(Step);
    self:SetValue(Value);
end

function GuildFinderGuildLvlMin_OnValueChanged(self)
    local slider_new_value = GuildFinderGuildLvlSlider_OnValueChanged(self);
    if slider_new_value > GuildFinderGuildLvlMax:GetValue() then
        GuildFinderGuildLvlMax:SetValue(slider_new_value)
    end
    --GuildFinderUpdateGuildsList();
    GuildFinder_Update();
end

function GuildFinderGuildLvlMax_OnValueChanged(self)
    local slider_new_value = GuildFinderGuildLvlSlider_OnValueChanged(self);
    if slider_new_value < GuildFinderGuildLvlMin:GetValue() then
        GuildFinderGuildLvlMin:SetValue(slider_new_value)
    end
    --GuildFinderUpdateGuildsList();
    GuildFinder_Update();
end

function GuildFinderGuildNumMembers_OnLoad(self,vText,Min,Max,Step,Value)
    self.text = vText;

    --i=(Min*100).."%";
    --j=(Max*100).."%";

    g=_G[self:GetName().."Text"]
    g:SetText(vText);
    g=_G[self:GetName().."Low"]
    g:SetText(Min + 1);
    g=_G[self:GetName().."High"]
    g:SetText(Max);
    self:SetMinMaxValues(Min,Max);
    self:SetValueStep(Step);
    self:SetValue(Value);
end

function GuildFinderGuildNumMembersMin_OnValueChanged(self)
    local slider_new_value = GuildFinderGuildNumMembersSlider_OnValueChanged(self);
    --if slider_new_value > GuildFinderGuildNumMembersMax:GetValue() then
        --GuildFinderGuildNumMembersMax:SetValue(slider_new_value)
    --end
    --print(GuildFinderGuildNumMembersMin:GetValue());
    --GuildFinderUpdateGuildsList();
    GuildFinder_Update();
end
 
function GuildFinderRoleButton_OnClick(self)
    local checked = self:GetChecked();
    if ( self:GetChecked() ) then
        PlaySound("igMainMenuOptionCheckBoxOn");
    else
        PlaySound("igMainMenuOptionCheckBoxOff");
    end
    SetLookingForGuildSettings(self:GetParent().param, checked);--********************************************************************************************************************
    GuildFinderBrowseButton_Update();
end

function GuildFinderStartFrame_OnShow(self)
    local bQuest, bDungeon, bRaid, bPvP, bRP, bWeekdays, bWeekends, bTank, bHealer, bDamage = GetLookingForGuildSettings();--*************************************************************************************************
    -- interests
    GuildFinderQuestButton:SetChecked(bQuest);
    GuildFinderDungeonButton:SetChecked(bDungeon);
    GuildFinderRaidButton:SetChecked(bRaid);
    GuildFinderPvPButton:SetChecked(bPvP);
    GuildFinderRPButton:SetChecked(bRP);
    -- availability
    GuildFinderWeekdaysButton:SetChecked(bWeekdays);
    GuildFinderWeekendsButton:SetChecked(bWeekends);
    -- roles
    GuildFinderTankButton.checkButton:SetChecked(bTank);
    GuildFinderHealerButton.checkButton:SetChecked(bHealer);
    GuildFinderDamagerButton.checkButton:SetChecked(bDamage);
    GuildFinderBrowseButton_Update();
    -- comment
    GuildFinderCommentEditBox:SetText(GetLookingForGuildComment());--*********************************************************************************************************************************************************************
end
 
function GuildFinderStartFrame_OnLoad(self)
    GuildFinderGuildLvlFrameText:SetText(GUILDFINDER_WORDS_GUILD_LVL);
    GuildFinderGuildNumMembersFrameText:SetText(GUILDFINDER_WORDS_GUILD_NUM_MEMBERS);
    GuildFinderInterestFrameText:SetText(GUILD_INTEREST);
    GuildFinderInterestFrame:SetHeight(74);
    GuildFinderAvailabilityFrameText:SetText(GUILD_AVAILABILITY);
    GuildFinderAvailabilityFrame:SetHeight(51);
    GuildFinderRolesFrameText:SetText(CLASS_ROLES);
    GuildFinderRolesFrame:SetHeight(83);
    GuildFinderCommentFrameText:SetText(COMMENT);
    GuildFinderCommentFrame:SetHeight(98);
 
    --******************************************************************************код в GuildFinderStartFrame_OnShow
     
    GuildFinderBrowseButton:SetWidth(max(116, GuildFinderBrowseButton:GetTextWidth() + 24));
end
 
function GuildFinderBrowseButton_Update()
    local bQuest, bDungeon, bRaid, bPvP, bRP, bWeekdays, bWeekends, bTank, bHealer, bDamage = GetLookingForGuildSettings();--******************************************************************************************************
    -- need to have at least 1 interest, 1 time, and 1 role checked to be able to list
    if ( bQuest or bDungeon or bRaid or bPvP or bRP ) and ( bWeekdays or bWeekends ) and ( bTank or bHealer or bDamage ) then
        GuildFinderBrowseButton:Enable();
        PanelTemplates_EnableTab(GuildFinderFrame, 2)
    else
        GuildFinderBrowseButton:Disable();
        PanelTemplates_DisableTab(GuildFinderFrame, 2)
    end
end
 
function GuildFinderComment_SaveText(self)
    self = self or GuildFinderCommentEditBox;
    SetLookingForGuildComment(self:GetText());--******************************************************************************************************************************************************************************
    self:ClearFocus();
end
 
function GuildFinderCheckButton_OnEnter(self)
    local interestType = INTEREST_TYPES[self:GetID()];
    if ( interestType ) then
        GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
        GameTooltip:SetText(_G["GUILD_INTEREST_"..interestType]);
        GameTooltip:AddLine(_G["GUILD_INTEREST_"..interestType.."_TOOLTIP"], 1, 1, 1, 1, 1);
        GameTooltip:Show();
    end
end

function GuildFinderUpdateGuildsList()
    local numGuilds = GetNumRecruitingGuilds();
    --print(numGuilds);
    local j = 0;
    for i = 1, numGuilds do
        local name, level, numMembers, achPoints, comment, cached, requestPending = GetRecruitingGuildInfo(i);
	if (level >= GuildFinderGuildLvlMin:GetValue()) and (level <= GuildFinderGuildLvlMax:GetValue()) and (numMembers >= GuildFinderGuildNumMembersMin:GetValue()) then
	    j = j + 1;
	    GuildFinderRecrutingGuilds[j] = {};
	    GuildFinderRecrutingGuilds[j].index = i;
	end
    end
    --numRecrGuilds = j;
    GuildFinderRecrutingGuilds.numGuilds = j;
    --print(GuildFinderRecrutingGuilds.numGuilds);
    GuildFinderGuildsFound:SetFormattedText(GUILDFINDER_WORDS_GUILDS_FOUND, j);
    --GuildFinder_Update();
end
 
--*******************************************************************************
--   Browse frame
--*******************************************************************************
 
function GuildFinderBrowseFrame_OnLoad(self)
    GuildFinderRequestButton:SetWidth(max(116, GuildFinderRequestButton:GetTextWidth() + 24));
    GuildFinderBrowseFrameContainer.update = GuildFinder_Update;
    HybridScrollFrame_CreateButtons(GuildFinderBrowseFrameContainer, "GuildFinderGuildTemplate", 0, 0);
	
    GuildFinderBrowseFrameContainerScrollBar.Show =
        function (self)
            GuildFinderBrowseFrameContainer:SetWidth(304);
            for _, button in next, GuildFinderBrowseFrameContainer.buttons do
                button:SetWidth(301);
                button.fullComment:SetWidth(223);
            end
            getmetatable(self).__index.Show(self);
        end
    GuildFinderBrowseFrameContainerScrollBar.Hide =
        function (self)
            GuildFinderBrowseFrameContainer:SetWidth(320);
            for _, button in next, GuildFinderBrowseFrameContainer.buttons do
                button:SetWidth(320);
                button.fullComment:SetWidth(242);
            end
            getmetatable(self).__index.Hide(self);
        end
 
    GuildFinder_Update();
    --GuildFinderUpdateGuildsList();
end
 
function GuildFinderBrowseFrame_OnShow(self)
    RequestRecruitingGuildsList();
    --GuildFinderUpdateGuildsList();
end
 
function GuildFinder_Update()
    GuildFinderUpdateGuildsList();
    local scrollFrame = GuildFinderBrowseFrameContainer;
    local offset = HybridScrollFrame_GetOffset(scrollFrame);
    local buttons = scrollFrame.buttons;
    local numButtons = #buttons;
    local button, index;
    --local numGuilds = GetNumRecruitingGuilds();
    local numGuilds = GuildFinderRecrutingGuilds.numGuilds;
    local _, numAppsRemaining = GetNumGuildMembershipRequests();
    local selection = GetRecruitingGuildSelection();
    
    for i = 1, numButtons do
        button = buttons[i];
        index = offset + i;
        if ( index <= numGuilds ) then
            local name, level, numMembers, achPoints, comment, cached, requestPending = GetRecruitingGuildInfo(GuildFinderRecrutingGuilds[index].index);
            button.name:SetText(name);
            button.level:SetText(level);
            button.numMembers:SetFormattedText(BROWSE_GUILDS_NUM_MEMBERS, numMembers);
            button.achPoints:SetText(achPoints);
            button.comment:SetText(comment);
            button.fullComment:SetText(comment);
            -- tabard
            local tabardInfo = { GetRecruitingGuildTabardInfo(GuildFinderRecrutingGuilds[index].index) };
            SetLargeGuildTabardTextures(nil, button.emblem, button.tabard, button.border, tabardInfo);
            -- selection
            local buttonHeight = GUILD_BUTTON_HEIGHT;
            if ( requestPending ) then
                button.selectedTex:Show();
                button.pendingFrame:Show();
            else
                button.pendingFrame:Hide();
                if ( GuildFinderRecrutingGuilds[index].index == selection ) then
                    button.selectedTex:Show();
                    local commentHeight = button.fullComment:GetHeight();
                    if ( commentHeight > GUILD_COMMENT_HEIGHT ) then
                        buttonHeight = GUILD_BUTTON_HEIGHT + commentHeight - GUILD_COMMENT_HEIGHT + GUILD_COMMENT_BORDER;
                    end
                else
                    button.selectedTex:Hide();
                end
            end
            button:SetHeight(buttonHeight);
             
            button:Show();
            button.index = GuildFinderRecrutingGuilds[index].index;
        else
            button:Hide();
        end
    end
 
    if ( not selection ) then
        HybridScrollFrame_CollapseButton(scrollFrame);
    end
     
    local totalHeight = numGuilds * GUILD_BUTTON_HEIGHT;
    if ( scrollFrame.largeButtonHeight ) then
        totalHeight = totalHeight + (scrollFrame.largeButtonHeight - GUILD_BUTTON_HEIGHT);
    end
    local displayedHeight = numButtons * GUILD_BUTTON_HEIGHT;
    HybridScrollFrame_Update(scrollFrame, totalHeight, displayedHeight);
 
    if ( selection and numAppsRemaining > 0 ) then
        GuildFinderRequestButton:Enable();
    else
        GuildFinderRequestButton:Disable();
    end
end
 
function GuildFinderGuild_OnClick(self, button)
    if ( button == "LeftButton" ) then
        local name, level, numMembers, achPoints, comment, cached, requestPending = GetRecruitingGuildInfo(self.index);
        if ( not requestPending ) then
            PlaySound("igMainMenuOptionCheckBoxOn");
            SetRecruitingGuildSelection(self.index);
            local commentHeight = self.fullComment:GetHeight();
            if ( commentHeight > GUILD_COMMENT_HEIGHT ) then
                local buttonHeight = GUILD_BUTTON_HEIGHT + commentHeight - GUILD_COMMENT_HEIGHT + GUILD_COMMENT_BORDER;
                self:SetHeight(buttonHeight);
                HybridScrollFrame_ExpandButton(GuildFinderBrowseFrameContainer, ((self.index - 1) * GUILD_BUTTON_HEIGHT), buttonHeight);
            else
                HybridScrollFrame_CollapseButton(GuildFinderBrowseFrameContainer);
            end
            GuildFinder_Update();
        end
    end
end
 
function GuildFinderGuild_ShowTooltip(self)
    local name = GetRecruitingGuildInfo(self.index);
    local bQuest, bDungeon, bRaid, bPvP, bRP, bWeekdays, bWeekends, bTank, bHealer, bDamage = GetRecruitingGuildSettings(self.index);
    GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
    GameTooltip:SetText(name);
    local buf = "";
    -- interests
    if ( bQuest ) then buf = buf.."\n"..QUEST_DASH..GUILD_INTEREST_QUEST; end
    if ( bDungeon ) then buf = buf.."\n"..QUEST_DASH..GUILD_INTEREST_DUNGEON; end
    if ( bRaid ) then buf = buf.."\n"..QUEST_DASH..GUILD_INTEREST_RAID; end
    if ( bPvP ) then buf = buf.."\n"..QUEST_DASH..GUILD_INTEREST_PVP; end
    if ( bRP ) then buf = buf.."\n"..QUEST_DASH..GUILD_INTEREST_RP; end
    GameTooltip:AddLine(GUILD_INTEREST..HIGHLIGHT_FONT_COLOR_CODE..buf);
    -- availability
    buf = "";
    if ( bWeekdays ) then buf = buf.."\n"..QUEST_DASH..GUILD_AVAILABILITY_WEEKDAYS; end
    if ( bWeekends ) then buf = buf.."\n"..QUEST_DASH..GUILD_AVAILABILITY_WEEKENDS; end
    GameTooltip:AddLine(GUILD_AVAILABILITY..HIGHLIGHT_FONT_COLOR_CODE..buf);
    -- roles
    buf = "";
    if ( bTank ) then buf = buf.."\n"..QUEST_DASH..TANK; end
    if ( bHealer ) then buf = buf.."\n"..QUEST_DASH..HEALER; end
    if ( bDamage ) then buf = buf.."\n"..QUEST_DASH..DAMAGER; end
    GameTooltip:AddLine(CLASS_ROLES..HIGHLIGHT_FONT_COLOR_CODE..buf);
     
    GameTooltip:Show();
end
 
function GuildFinder_RequestMembership()
    StaticPopupSpecial_Show(GuildFinderRequestMembershipFrame);
    PlaySound("igMainMenuOpen");
    local name, level = GetRecruitingGuildInfo(GetRecruitingGuildSelection());
    GuildFinderRequestMembershipFrameGuildName:SetText(name);
    GuildFinderRequestMembershipFrameGuildLevel:SetFormattedText(GUILD_LEVEL, level);
    GuildFinderRequestMembershipEditBox:SetText(GetLookingForGuildComment());
end
 
function GuildFinderRequestMembershipFrame_SendRequest()
    StaticPopupSpecial_Hide(GuildFinderRequestMembershipFrame);
    RequestGuildMembership(GuildFinderRequestMembershipFrameGuildName:GetText(), GuildFinderRequestMembershipEditBox:GetText());
    SetRecruitingGuildSelection(nil);
    GuildFinder_Update();
end
 
--*******************************************************************************
--   Apps frame
--*******************************************************************************
 
function GuildFinderAppsFrame_OnLoad(self)
    GuildFinderAppsFrameContainer.update = GuildFinderApps_Update;
    HybridScrollFrame_CreateButtons(GuildFinderAppsFrameContainer, "GuildFinderAppTemplate", 0, 0);
     
    GuildFinderAppsFrameContainerScrollBar.Show =
        function (self)
            GuildFinderAppsFrameContainer:SetWidth(304);
            for _, button in next, GuildFinderAppsFrameContainer.buttons do
                button:SetWidth(301);
            end
            getmetatable(self).__index.Show(self);
        end
    GuildFinderAppsFrameContainerScrollBar.Hide =
        function (self)
            GuildFinderAppsFrameContainer:SetWidth(320);
            for _, button in next, GuildFinderAppsFrameContainer.buttons do
                button:SetWidth(320);
            end
            getmetatable(self).__index.Hide(self);
        end
         
    GuildFinderApps_Update();
end
 
function GuildFinderApps_Update()
    local scrollFrame = GuildFinderAppsFrameContainer;
    local offset = HybridScrollFrame_GetOffset(scrollFrame);
    local buttons = scrollFrame.buttons;
    local numButtons = #buttons;
    local button, index;
    local numApps = GetNumGuildMembershipRequests();
 
    if ( numApps == 0 ) then
        GuildFinderFrameTab3:SetText(LFGUILD_TAB_REQUESTS_NONE);
    else
        GuildFinderFrameTab3:SetFormattedText(LFGUILD_TAB_REQUESTS, numApps);
    end
    PanelTemplates_TabResize(GuildFinderFrameTab3, 0);
     
    for i = 1, numButtons do
        button = buttons[i];
        index = offset + i;
        if ( index <= numApps ) then
            local name, timeSince, timeLeft, declined = GetGuildMembershipRequestInfo(index);
            button.name:SetText(name);
            -- time left
            local daysLeft = floor(timeLeft / 86400); -- seconds in a day
            if ( daysLeft < 1 ) then
                button.timeLeft:SetText(GUILD_FINDER_LAST_DAY_LEFT);
            else
                button.timeLeft:SetFormattedText(GUILD_FINDER_DAYS_LEFT, daysLeft);
            end
            button:Show();
            button.index = index;
        else
            button:Hide();
        end
    end
    local totalHeight = numApps * APP_BUTTON_HEIGHT;
    local displayedHeight = numButtons * APP_BUTTON_HEIGHT;
    HybridScrollFrame_Update(scrollFrame, totalHeight, displayedHeight);
end
 
function GuildFinderApp_ShowTooltip(self)
    local name = GetGuildMembershipRequestInfo(self.index);
    local bQuest, bDungeon, bRaid, bPvP, bRP, bWeekdays, bWeekends, bTank, bHealer, bDamage = GetGuildMembershipRequestSettings(self.index);
    GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
    GameTooltip:SetText(name);
    local buf = "";
    -- interests
    if ( bQuest ) then buf = buf.."\n"..QUEST_DASH..GUILD_INTEREST_QUEST; end
    if ( bDungeon ) then buf = buf.."\n"..QUEST_DASH..GUILD_INTEREST_DUNGEON; end
    if ( bRaid ) then buf = buf.."\n"..QUEST_DASH..GUILD_INTEREST_RAID; end
    if ( bPvP ) then buf = buf.."\n"..QUEST_DASH..GUILD_INTEREST_PVP; end
    if ( bRP ) then buf = buf.."\n"..QUEST_DASH..GUILD_INTEREST_RP; end
    GameTooltip:AddLine(GUILD_INTEREST..HIGHLIGHT_FONT_COLOR_CODE..buf);
    -- availability
    buf = "";
    if ( bWeekdays ) then buf = buf.."\n"..QUEST_DASH..GUILD_AVAILABILITY_WEEKDAYS; end
    if ( bWeekends ) then buf = buf.."\n"..QUEST_DASH..GUILD_AVAILABILITY_WEEKENDS; end
    GameTooltip:AddLine(GUILD_AVAILABILITY..HIGHLIGHT_FONT_COLOR_CODE..buf);
    -- roles
    buf = "";
    if ( bTank ) then buf = buf.."\n"..QUEST_DASH..TANK; end
    if ( bHealer ) then buf = buf.."\n"..QUEST_DASH..HEALER; end
    if ( bDamage ) then buf = buf.."\n"..QUEST_DASH..DAMAGER; end
    GameTooltip:AddLine(CLASS_ROLES..HIGHLIGHT_FONT_COLOR_CODE..buf);
     
    GameTooltip:Show();
end